<?php /*
Plugin Name: Charlies content
Version: 1.7.g
Description: Charlies content is a global solution for none picture files.
Plugin URI: http://phpwebgallery.net/ext/extension_view.php?eid=119
Author: VDigital, rvelices (PhpWebGallery team)
Author URI: http://www.phpwebgallery.net
*/

/** Your customization begins here
 *
 * How does that work:
 *
 * - All media file have to be broadcasted via an embedded player
 * - so link its extention to a player name as to be define
 * - the same player can be used for several extentions
 */
  global $conf, $charlie;

  if (!isset($charlie['Flash']))
    { $charlie['Flash'] = array('swf',); }
  if (!isset($charlie['Music']))
    { $charlie['Music'] = array('pls','m3u','wav','mid','au','aif',); }
  if (!isset($charlie['mp3Player']))
    { $charlie['mp3Player'] = array('mp3',); }
  if (!isset($charlie['FlvStreamer']))
    { $charlie['FlvStreamer'] = array('flv',); }
  if (!isset($charlie['Acrobat']))
    { $charlie['Acrobat'] = array('pdf',); }
  if (!isset($charlie['WMplayer']))
    { $charlie['WMplayer'] = array('asf','wmv','divx','xvid',); }
  if (!isset($charlie['QuickTime']))
    { $charlie['QuickTime'] = array('qt','mov','mpg','mpeg',
                                    'mp4','avi','3gp','3g2',); }
  if (!isset($charlie['Archive']))
    { $charlie['Archive'] = array('zip','rar',); }

  /* Note: Uppercase extensions are no longuer requested */
  /**
   * That means you must have a tpl file for each... player
   * like for Flash => ./plugings/charlies_content/flash_content.tpl
   * like for Music => ./plugings/charlies_content/music_content.tpl
   *
   * Player name is in lower-case followed by _content.tpl
   * size or other parameters useful in your template can be obtain
   * use the forum on our web site to obtain how to get them
   * and that's all !!!
   *
   *
   * All $charlie['xxxxx'] can be initialized in conf_local.inc.php */

/** History ***************
 2008/03/26: error_reporting(E_ERROR | E_WARNING | E_PARSE);
             during getid3 call (Only one referenced case).             
 2008/02/22:
 * 3GP support : video streams from mobile phones.
   There are two different standards for this format:
   3gp for GSM-based Phones, or 3g2 for CDMA-based Phones.
 * $page['slideshow'] active/inactive support for "Pause" enhancement 
   so Charlies won't act on active slideshow but will act on Slideshow pause
 **/

if (!defined('PHPWG_ROOT_PATH')) die('Hacking attempt!');

add_event_handler('render_element_content', 
                  'render_Charlie_element_content', 40, 2 );

$all = array();
foreach ($charlie as $ext)
{
  $all = array_merge ($all, $ext);
}
$conf['file_ext'] = array_merge (
    $conf['file_ext'],
    $all,
    array_map('strtoupper', $all)
  );


/**
 * Only if picture.php is active
 * Add a XHTML tag in HEAD section and
 * Include Charlies content
 */
function render_Charlie_element_content($content, $picture)
{
  global $template, $charlie, $page, $conf;

  if ( isset($page['slideshow']) and $page['slideshow'] )
  { // nothing to do on slideshow other media aren't usable
    return $content;
  }

  if ( @$picture['is_picture'] )
  { // nothing to do with regular picture
    return $content;
  }

  $all = array();
  foreach ($charlie as $ext)
  {
    $all = array_merge ($all, $ext);
  }

  $charlie['all'] = $all;
  $extension = strtolower(get_extension($picture['file']));
  if (!in_array($extension, $charlie['all']))
  { // in fact nothing to do (Lucky Charlies)
    return $content;
  }
  // Essai pour rsoudre le fait que Charlies_content() ne connait pas $conf
  if (!isset($conf['video_default_width']))
    { $conf['video_default_width'] = 320; }
  if (!isset($conf['video_default_height']))
    { $conf['video_default_height'] = 240; }
  unset($charlie['all']);
  include_once(PHPWG_PLUGINS_PATH.'charlies_content/charlies.inc.php');
  return Charlies_content($picture);
}

?>